// 1. The Optional type is an enum
enum Optional<T> {
    case none
    case some(T)
}

// 2. How to use the Optional enum directly
let longFormMethod: Optional<Int> = .none

// 3. How to use the special short form method (preferred)
let shortFormMethod: Int? = nil

// 4. Optional binding using short form
let optional: Int? = nil
if let value = optional {
    print("We have unwrapped \(value)")
} else {
    print("No value found")
}

// 5. Optional binding using long form
let optionalLongForm: Optional<Int> = .none
if case .some(let value) = optionalLongForm {
    print("We have unwrapped \(value)")
} else {
    print("No value found")
}
